'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 10 September 2002 at 1:03:16 am'!

!ScrollPane methodsFor: 'access' stamp: 'fg 8/1/2001 00:56'!
highlightedIndex
	scroller submorphs withIndexDo: [:any :i | any highlightedForMouseDown ifTrue: [^ i]].
	^ 0! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'fg 7/30/2001 20:46'!
initialize
	super initialize.
	self enableDragNDrop! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 02:46'!
startDrag: evt
	| ddm itemMorph itemModel index |
	self dragEnabled 
		ifTrue:
			[index _ self highlightedIndex.
			index > 0 
				ifTrue: 
					[itemMorph _ scroller submorphs at: index.
					itemModel _ self model getItemAt: index fromListNamed: getListSelector]].
	(itemMorph isNil or: [evt hand hasSubmorphs]) ifTrue: [^self].
	itemMorph highlightForMouseDown: false.
	model okToChange 
		ifFalse: 
			[Cursor normal show.
			^ self  "No change if model is locked" ].

	"itemMorph ~= self selection ifTrue: [self setSelectedMorph: itemMorph]."
	ddm _ TransferMorph withPassenger: (self model dragPassengerFor: itemModel inMorph: self) from: self.
	ddm dragTransferType: (self model dragTransferTypeForMorph: self).
	Preferences dragNDropWithAnimation
			ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
	evt hand grabMorph: ddm.
	evt hand releaseMouseFocus: self.! !


!StringHolder methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:11'!
dragTransferTypeForMorph: dragSource 
	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [dragSource getListSelector]! !

!StringHolder methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:11'!
getItemAt: anInteger fromListNamed: aSymbol 
	self subclassResponsibility
! !


!Browser methodsFor: 'drag and drop' stamp: 'fg 7/30/2001 21:17'!
acceptDroppingMorph: transferMorph event: evt inMorph: dstListMorph 
	"Here we are fetching informations from the dropped transferMorph and 
	             performing the correct action for this drop."

	| srcType success srcBrowser |
	success _ false.
	srcType _ transferMorph dragTransferType.
	srcBrowser _ transferMorph source model.
	srcType == #messageList ifTrue: [success _ self
					acceptMethod: transferMorph passenger methodSelector
					messageCategory: srcBrowser selectedMessageCategoryName
					class: transferMorph passenger methodClass
					atListMorph: dstListMorph
					internal: self == srcBrowser
					copy: transferMorph shouldCopy].
	srcType == #classList
		ifTrue: 
			[success _ self
				changeCategoryForClass: transferMorph passenger
				srcSystemCategory: srcBrowser selectedSystemCategoryName
				atListMorph: dstListMorph
				internal: self == srcBrowser
				copy: transferMorph shouldCopy].
	^success!
]style[(67 637 4 223)f1b,f1,f1cblue;b,f1! !

!Browser methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 12:08'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ Smalltalk at: ((self classList at: anInteger) withBlanksTrimmed asSymbol)].
	aSymbol == #messageCategoryList 
		ifTrue: [^ self messageCategoryList at: anInteger].
	aSymbol == #messageList
		ifTrue: [^ MethodReference class: self selectedClassOrMetaClass selector: (self messageList at: anInteger)].
	aSymbol == #systemCategoryList
		ifTrue: [^ self systemCategoryList at: anInteger].
	aSymbol == #systemCategorySingleton
		ifTrue: [^ self systemCategorySingleton at: anInteger].

	self error: 'You should program the #', aSymbol, ' case.'
! !

!Browser methodsFor: 'drag and drop' stamp: 'fg 7/16/2001 13:40'!
systemCategoryListDrag: item
	^ item contents! !


!ChangeSorter methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 01:24'!
classAt: anInteger
	| className tokens |
	className _ self classList at: anInteger.
	tokens _ className findTokens: Character separators.
	^ Smalltalk at: tokens first asSymbol! !

!ChangeSorter methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 11:48'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ self classAt: anInteger].
	aSymbol == #changeSetList 
		ifTrue: [^ ChangeSorter changeSetNamed: (self changeSetList at: anInteger)].
	aSymbol == #messageList
		ifTrue: [^ MethodReference class: self selectedClassOrMetaClass selector: (self messageList at: anInteger)].

	self error: 'You should program the #', aSymbol, ' case.'
! !


!Debugger methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 11:50'!
getItemAt: anInteger fromListNamed: aSymbol 
	| who | 
	aSymbol == #contextStackList 
		ifTrue: 
			[who _ (contextStack at: anInteger) method who.
			^ MethodReference class: who first selector: who second].

	self error: 'You should program the #', aSymbol, ' case.'
! !


!FileContentsBrowser methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 12:09'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ Smalltalk at: ((self classList at: anInteger) withBlanksTrimmed asSymbol)].
	aSymbol == #messageList
		ifTrue: [self flag: #toBeImplemented.
				^MethodReference class: self selectedClassOrMetaClass selector: (self messageList at: anInteger)].
	
	^ super getItemAt: anInteger fromListNamed: aSymbol 
! !


!FileList methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 12:09'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #fileList 
		ifTrue: [^ self fileList at: anInteger].

	aSymbol == #volumeList 
		ifTrue: [^ (self volumeList at: anInteger) withBlanksTrimmed].

	self error: 'You should program the #', aSymbol, ' case.'! !


!Inspector methodsFor: 'selecting' stamp: 'fg 8/7/2001 12:15'!
selection
	^ self selectionAtIndex: selectionIndex
! !

!Inspector methodsFor: 'selecting' stamp: 'fg 8/7/2001 12:14'!
selectionAtIndex: anInteger
	"The receiver has a list of variables of its inspected object.
	One of these is selected. Answer the value of the selected variable."
	| basicIndex |
	anInteger = 0 ifTrue: [^ ''].
	anInteger = 1 ifTrue: [^ object].
	anInteger = 2 ifTrue: [^ object longPrintString].
	(anInteger - 2) <= object class instSize
		ifTrue: [^ object instVarAt: anInteger - 2].
	basicIndex _ anInteger - 2 - object class instSize.
	(object basicSize <= (self i1 + self i2)  or: [basicIndex <= self i1])
		ifTrue: [^ object basicAt: basicIndex]
		ifFalse: [^ object basicAt: object basicSize - (self i1 + self i2) + basicIndex]! !

!Inspector methodsFor: 'drag & drop' stamp: 'fg 8/7/2001 12:17'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #fieldList 
		ifTrue: [^ self selectionAtIndex: anInteger].

	self error: 'You should program the #', aSymbol, ' case.'! !


!Inspector class methodsFor: 'instance creation' stamp: 'r++ 12/26/2000 23:15'!
openAsMorphOn: anObject withLabel: aLabel
	"(Inspector openAsMorphOn: SystemOrganization) openInMVC"
	| window inspector |
	inspector _ self inspect: anObject.
	window _ (SystemWindow labelled: aLabel) model: inspector.
	window addMorph: (
		PluggableListMorph new
			doubleClickSelector: #inspectSelection;
			on: inspector list: #fieldList
			selected: #selectionIndex
			changeSelected: #toggleIndex:
			menu: ((inspector isMemberOf: DictionaryInspector)
					ifTrue: [#dictionaryMenu:]
					ifFalse: [#fieldListMenu:])
			keystroke: #inspectorKey:from:;
			dragEnabled: true)
			
		frame: (0@0 corner: self horizontalDividerProportion @ self verticalDividerProportion).
	window addMorph: (PluggableTextMorph on: inspector text: #contents accept: #accept:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (self horizontalDividerProportion @0 corner: 1@self verticalDividerProportion).
	window addMorph: ((PluggableTextMorph on: inspector text: #trash accept: #trash:
				readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
					askBeforeDiscardingEdits: false)
		frame: (0@self verticalDividerProportion corner: 1@1).
	window setUpdatablePanesFrom: #(fieldList).
	window position: 16@0.  "Room for scroll bar."
	^ window! !


!MessageSet methodsFor: 'drag and drop' stamp: 'fg 11/30/2001 11:45'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #messageList
		ifTrue: [^ self messageList at: anInteger].

	self error: 'You should program the #', aSymbol, ' case.'! !


!ProtocolBrowser methodsFor: 'private' stamp: 'fg 11/30/2001 13:15'!
fromSelection: aText setClassAndSelectorIn: csBlock
	"Decode strings of the form    <selectorName> (<className> [class])"

	| i classAndSelString selString sel |

	sel _ aText ifNil: [^ csBlock value: nil value: nil].
	(sel isKindOf: MethodReference) ifTrue: [
		sel setClassAndSelectorIn: csBlock
	] ifFalse: [
		selString _ sel asString.
		i _ selString indexOf: $(.
		"Rearrange to  <className> [class] <selectorName> , and use MessageSet"
		classAndSelString _ (selString copyFrom: i + 1 to: selString size - 1) , ' ' ,
							(selString copyFrom: 1 to: i - 1) withoutTrailingBlanks.
		MessageSet parse: classAndSelString toClassAndSelector: csBlock.
	].
! !


!Lexicon methodsFor: 'drag and drop' stamp: 'fg 11/30/2001 13:25'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #messageList
		ifTrue: 
			[self 
				fromSelection: (self messageList at: anInteger) 
				setClassAndSelectorIn: [:c :s | ^ MethodReference class: c selector: s]].
	aSymbol == #categoryList
		ifTrue: [^ self categoryList at: anInteger].		

	self error: 'You should program the #', aSymbol, ' case.'
! !


!SelectorBrowser methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 11:17'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ self classList at: anInteger].
	aSymbol == #messageList 
		ifTrue: [^ self messageList at: anInteger].	
	
	self error: 'You should program the ', aSymbol printString, ' case.'! !


!TransferMorph methodsFor: 'testing' stamp: 'fg 7/30/2001 20:30'!
shiftPressed
	^ self shouldCopy! !

!TransferMorph methodsFor: 'testing' stamp: 'fg 8/2/2001 00:50'!
shouldRemove
	^ self shouldCopy not! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'fg 8/6/2001 18:21'!
justDroppedInto: targetMorph event: anEvent 
	"If only world wants this TransferMorph, treat it as unaccepted (see also >>delete)."

	super justDroppedInto: targetMorph event: anEvent.
	accepted _ targetMorph ~= self world.
	accepted 
		ifTrue: 
			[self animationForMoveSuccess: accepted.
			self dropNotifyRecipient 
				ifNotNil: [self dropNotifyRecipient dropAcceptedMorph: self from: targetMorph]]
		ifFalse: 
			[anEvent hand newKeyboardFocus: nil.
			self result openAttachedTo: anEvent hand].
	self delete! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'fg 8/4/2001 08:10'!
result
	^ Sensor shiftPressed
		ifTrue: [passenger wrappedClass]
		ifFalse: [passenger]! !


!VersionsBrowser methodsFor: 'drag and drop' stamp: 'fg 8/7/2001 12:18'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #list 
		ifTrue: [^ self changeList at: anInteger].

	self error: 'You should program the #', aSymbol, ' case.'! !

Browser removeSelector: #dragPassengerFor:inMorph:!
