'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 10 September 2002 at 1:03:09 am'!
"Change Set:		MW-extensions
Date:			9 September 2002
Author:			Francisco Garau

See the MorphicWrapper class>>history for more documentation about the MW package.
"!


!Object methodsFor: 'error handling' stamp: 'LC 12/11/2000 08:06'!
confirm: queryString at: point
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	"nil confirm: 'Are you hungry?'"

	^ PopUpMenu confirm: queryString at: point! !

!Object methodsFor: 'morphic wrappers' stamp: 'r++ 11/28/1999 22:57'!
asMorph
	^ self morphicWrapperClass on: self! !

!Object methodsFor: 'morphic wrappers' stamp: 'fg 8/3/2001 19:31'!
hasNiceWrapper
	^ self morphicWrapperClass ~~ MorphicWrapper! !

!Object methodsFor: 'morphic wrappers' stamp: 'LC 5/14/2000 08:57'!
morphicWrapperClass
	"Answer a default MorphicWrapper class that can represent any object in a WorldMorph"
	^ MorphicWrapper! !

!Object methodsFor: 'morphic wrappers' stamp: 'fg 8/6/2001 18:07'!
openAttachedTo: aHand
	self asMorph openAttachedTo: aHand
! !

!Object methodsFor: 'morphic wrappers' stamp: 'fg 8/11/2001 22:21'!
uml
	^ self diagramMorph! !

!Object methodsFor: 'morphic wrappers' stamp: 'fg 7/31/2001 02:03'!
wrappedClass
	^ self class! !


!Behavior methodsFor: 'accessing method dictionary' stamp: 'LC 11/4/2000 14:48'!
| selector
	^ self >> selector! !

!Behavior methodsFor: 'user interface' stamp: 'fg 7/31/2001 17:49'!
browseCategory
	| newBrowser |
	newBrowser _ Browser new.
	newBrowser systemCategoryListIndex: (SystemOrganization indexOfCategoryNamed: self category).
	newBrowser setClass: nil selector: nil.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil) label: self category! !

!Behavior methodsFor: 'user interface' stamp: 'fg 7/16/2001 10:21'!
browseHierarchy
	| newBrowser |
	newBrowser _  HierarchyBrowser new initHierarchyForClass: self.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil) 
		label: self name, ' hierarchy'! !

!Behavior methodsFor: 'morphic wrappers' stamp: 'fg 8/13/2001 12:09'!
diagramMorph
	| box font title diagram boxColor titleColor |
	boxColor _ Color r: 0.599 g: 0.8 b: 1.0.
	titleColor _ Color r: 1.0 g: 0.8 b: 0.4.
	diagram _ Morph new
		setBalloonText: 'I am a ', self name, ' diagram';
		color: boxColor;
		extent: 20@20;
		yourself.		
	box _ AlignmentMorph new
		lock;
		extent: 20@20;
		listDirection: #topToBottom;
		color: boxColor;
		layoutInset: 4;
		borderWidth: 3;
		borderColor: #raised;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		yourself.
	font _ TextStyle default fontAt: 1.
	self instVarNames do: 
		[:each |
		box addMorphBack: (StringMorph new contents: each; font: font)].
	title _ AlignmentMorph new
		color: titleColor;
		borderWidth: 1;
		borderColor: #inset;
		addMorph:
			(StringMorph
				contents: self name
				font: (StrikeFont familyName: 'DefaultTextStyle' size: 18));
		yourself.
	box addMorph: title.
	diagram addMorph: box.
	diagram bounds: diagram fullBounds.
	^ diagram! !

!Behavior methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Boolean methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Character methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Class methodsFor: 'initialize-release' stamp: 'LC 11/4/2000 14:49'!
subclass: aString
	| subclass |
	subclass _ self subclass: aString asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category asString.
	subclass ifNotNil: [Smalltalk logChange: subclass definition].
	^ subclass! !

!Class methodsFor: 'morphic wrappers' stamp: 'r++ 2/19/2000 19:26'!
morphicWrapperClass
	^ ClassMorphicWrapper! !


!ClassOrganizer methodsFor: 'accessing' stamp: 'fg 7/31/2001 17:54'!
indexOfCategoryNamed: categoryName
	^ categoryArray indexOf: categoryName ifAbsent: [^nil].
! !


!CompiledMethod methodsFor: 'morphic wrapper' stamp: 'r++ 2/19/2000 19:56'!
asMorph
	^ (MethodModel class: self who first selector: self selector) asMorph! !

!CompiledMethod methodsFor: 'morphic wrapper' stamp: 'fg 8/1/2001 01:23'!
hasNiceWrapper
	^ true! !


!Date methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!Metaclass methodsFor: 'morphic wrappers' stamp: 'fg 8/1/2001 17:38'!
hasNiceWrapper
	^ false! !


!MethodReference methodsFor: 'morphic wrappers' stamp: 'fg 8/6/2001 21:27'!
asMorph
	^ MethodModel class: self actualClass selector: self methodSymbol! !

!MethodReference methodsFor: 'morphic wrappers' stamp: 'fg 8/7/2001 11:41'!
methodClass
	^ self actualClass! !

!MethodReference methodsFor: 'morphic wrappers' stamp: 'fg 8/7/2001 11:40'!
methodSelector
	^ self methodSymbol! !

!MethodReference methodsFor: 'morphic wrappers' stamp: 'fg 8/7/2001 11:56'!
wrappedClass
	^ self actualClass! !


!MethodReference class methodsFor: 'instance creation' stamp: 'fg 8/7/2001 11:30'!
class: aClass selector: aSymbol
	"
	MethodReference class: Object selector: #yourself
	MethodReference class: Object class selector: #readFrom: 
	"
	^ self new setClass: aClass methodSymbol: aSymbol stringVersion: nil ! !


!Morph methodsFor: 'accessing' stamp: 'LC 5/12/2000 20:05'!
names
	^ (self world ifNil: [^ #()]) namesFor: self! !

!Morph methodsFor: 'submorphs-add/remove' stamp: 'RAA 4/23/2001 16:55'!
delete
	"Remove the receiver as a submorph of its owner and make its new owner be nil."
	| aWorld |
	aWorld _ self world ifNil: [World].	"or some proper of getting the World"

	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little protection - raa"
	aWorld ifNotNil: [
		aWorld currentHand ifNotNilDo: [ :h | h disableGenieFocus: self].
	].

	owner ifNotNil:
		[(extension == nil or: [self player == nil])
		ifTrue: [owner privateRemoveMorph: self.
				owner _ nil]
		ifFalse: ["Player must be notified"
				owner privateRemoveMorph: self.
				owner _ nil.
				self player noteDeletionOf: self fromWorld: aWorld]
		].! !

!Morph methodsFor: 'submorphs-add/remove' stamp: 'nk 2/26/2001 23:50'!
deleteMorphs: aCollection
	aCollection do: [ :ea | ea delete ]! !

!Morph methodsFor: 'dropping/grabbing' stamp: 'LC 12/10/2000 21:32'!
slideToTrash: evt 
	| aWorld trash morph |
	aWorld _ self world.
	trash _ aWorld findA: TrashCanMorph.
	trash
		ifNil: [trash _ TrashCanMorph new.
			"self world addMorph: (morph _ Morph new extent: 0 @ 0).
			5
				timesRepeat: [morph position: aWorld bounds atRandom.
					self runTo: morph]."
			aWorld addMorph: trash.
			trash position: aWorld bounds bottomLeft + (0 @ trash extent y negated).
			"morph delete"].
	evt hand attachMorph: self.
	trash state: #pressed.
	self delete.
	trash acceptDroppingMorph: self event: evt.
	trash mouseUp: evt.
	trash shake! !

!Morph methodsFor: 'testing' stamp: 'LC 5/14/2000 08:51'!
isMorphicWrapper
	^ false! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 1/19/2002 11:26'!
acceptBalloon: aCodeBalloon 
	| fail result hand string morphResult |
	aCodeBalloon delete.
	string _ self transformTypedCode: aCodeBalloon contents withBlanksTrimmed.
	string isEmpty
		ifTrue: [^ self].
	fail _ Object new.
	result _ [Compiler new
				evaluate: aCodeBalloon string intendedMessage
				in: nil
				to: self receiver
				notifying: aCodeBalloon string
				ifFail: [fail]]
				on: Error
				do: [:ex | ^self highlightError].
	hand _ aCodeBalloon target.
	result == fail
		ifTrue: [hand attachMorph: aCodeBalloon;
				 newKeyboardFocus: aCodeBalloon.
			^ self].
	(self exitIfNeeded: string result: result) 
		ifTrue: [^ self].
	morphResult _ result asMorph.
	hand newKeyboardFocus: nil.
	self attachMorphResult: morphResult to: hand from: string givingResult: result.
	! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 8/3/2001 16:41'!
aerialTarget
	^ self! !

!Morph methodsFor: 'morphic wrappers' stamp: 'sd 1/2/2002 10:56'!
attachMorphResult: morphResult to: hand from: string givingResult: result
	"subclasses may override. To attach a result invoke attachResult:to:"

	morphResult == self
		ifTrue: [self resultIsMe]
		ifFalse: [self attachResult: morphResult to: hand]
	! !

!Morph methodsFor: 'morphic wrappers' stamp: 'sd 1/2/2002 10:39'!
attachResult: morphResult to: hand

	morphResult openAttachedTo: hand
	
	! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 8/6/2001 16:00'!
attachedToHand: aHandMorph
	aHandMorph attachMorph: self withDelta: self bounds extent // 2! !

!Morph methodsFor: 'morphic wrappers' stamp: 'sd 1/2/2002 11:03'!
exitIfNeeded: string result: result
	"a new hook because some people may not like the ending . approach"

	^ (string last = $.)
		! !

!Morph methodsFor: 'morphic wrappers' stamp: 'LC 6/20/1999 20:54'!
globe
	| g |
	self world isNil ifTrue: [^ self].
	GlobingMorph isGlobingOn ifFalse: [^ self].
	#(1 1 -1 ) atRandom > 0 ifTrue: [^ self].
	g _ GlobingMorph new center: self bounds atRandom;
			 velocity: 0 @ #(3 5 8 11 15 21 25 ) atRandom negated.
	self world addMorph: g.
	g borderColor: Color random.
	g startStepping! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 7/15/2001 02:57'!
hasNiceWrapper
	^ true! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 8/6/2001 17:55'!
openAttachedTo: aHand
	(self wrapee hasNiceWrapper or: [Preferences exploreComplexMorphicWrappers not])
		ifTrue: [self attachedToHand: aHand]
		ifFalse: [self wrapee explore]! !

!Morph methodsFor: 'morphic wrappers' stamp: 'r++ 2/19/2000 18:53'!
receiver
	^ self! !

!Morph methodsFor: 'morphic wrappers' stamp: 'sd 1/2/2002 10:30'!
resultIsMe
	"hook because some people may want to do something else when the result is self"

	self shake! !

!Morph methodsFor: 'morphic wrappers' stamp: 'LC 2/19/2000 18:20'!
runAndAttachTo: aMorph 
	| w |
	w _ self world ifNil: [aMorph world].
	w ifNotNil: [w addMorph: self].
	CarryingMorph carryAndAttach: self to: aMorph! !

!Morph methodsFor: 'morphic wrappers' stamp: 'LC 6/19/1999 20:28'!
runTo: aMorph 
	CarryingMorph carry: self to: aMorph! !

!Morph methodsFor: 'morphic wrappers' stamp: 'r++ 2/20/2000 22:10'!
shake: n
	ShakingMorph shake: self intensity: n! !

!Morph methodsFor: 'morphic wrappers' stamp: 'r++ 2/21/2000 06:52'!
talkToMe: hand 
	CodeBalloonMorph for: self hand: hand.
! !

!Morph methodsFor: 'morphic wrappers' stamp: 'sd 12/5/2001 19:08'!
transformTypedCode: aString
	"per default the code is not transformed by subclasses may change that"
	^ aString ! !

!Morph methodsFor: 'morphic wrappers' stamp: 'fg 7/15/2001 02:05'!
wrapee
	"I am not wrapping anyone, so I answer myself"
	^ self! !

!Morph methodsFor: 'special fx' stamp: 'fg 12/10/2001 12:09'!
highlightError
	| highlight |
	highlight _ (Morph new)
			bounds: self fullBounds;
			color: ((Color red) alpha: 0.4).
	self pasteUpMorph addMorphFront: highlight.
	highlight shake.
	self addAlarm: #deleteMorphs: with: (Array with: highlight) after: 1000.
! !

!Morph methodsFor: 'special fx' stamp: 'fg 8/11/2001 15:33'!
shake
	self bounds area < 140000 
		ifTrue: [self shake: 10]
		ifFalse: [self comeToFront]
! !


!HandMorph methodsFor: 'focus handling' stamp: 'fg 11/28/2001 14:39'!
xxxnewKeyboardFocus: aMorphOrNil 
	"Make the given morph the new keyboard focus, canceling the previous 
	keyboard focus if any. If the argument is nil, the current keyboard 
	focus is cancelled."
	| oldFocus newKeyboardFocus |
	oldFocus _ self keyboardFocus.
	newKeyboardFocus _ aMorphOrNil
				ifNil: [self world].
	self keyboardFocus: newKeyboardFocus.
	oldFocus
		ifNotNil: [oldFocus == aMorphOrNil
				ifFalse: [oldFocus keyboardFocusChange: false.
					newKeyboardFocus
						ifNotNil: [newKeyboardFocus keyboardFocusChange: true]]]! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'fg 8/6/2001 15:30'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."

	self attachMorph: m withDelta: m bounds extent // 2
! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'fg 8/6/2001 15:28'!
attachMorph: m withDelta: aPoint
	"Position the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	m isMorph ifFalse: [^ self].
	m isWorldOrHandMorph ifTrue: [^ self].
	self releaseMouseFocus. "Break focus"
	m position: (self position - aPoint).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.! !


!MenuMorph methodsFor: 'construction' stamp: 'LC 2/10/2000 14:09'!
addFirst: aString target: target selector: aSymbol argument: arg
	self addFirst: aString
		target: target
		selector: aSymbol
		argumentList: (Array with: arg)
! !

!MenuMorph methodsFor: 'construction' stamp: 'LC 2/10/2000 14:08'!
addFirst: aString target: target selector: aSymbol argumentList: argList
	| item |
	item _ MenuItemMorph new
		contents: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray.
	self addMorph: item.
! !


!Number methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true
! !


!Parser methodsFor: 'error correction' stamp: 'LC 11/4/2000 17:20'!
correctVariable: proposedVariable interval: spot
	"Correct the proposedVariable to a known variable, or declare it as a new
	variable if such action is requested.  We support declaring lowercase
	variables as temps, and uppercase variables as Globals or ClassVars,
	depending on whether the context is nil (class=UndefinedObject).
	Spot is the interval within the test stream of the variable."

	| alternatives aStream choice userSelection temp binding globalToo |
	"If we can't ask the user for correction, make it undeclared"
	self interactive ifFalse: [^ encoder undeclared: proposedVariable].

	temp _ proposedVariable first isLowercase.
	"First check to see if the requestor knows anything about the variable"
	(temp and: [(binding _ requestor bindingOf: proposedVariable) notNil])
		ifTrue: [^ encoder global: binding name: proposedVariable].
	userSelection _ requestor selectionInterval.
	requestor selectFrom: spot first to: spot last.
	requestor select.

	alternatives _ encoder possibleVariablesFor: proposedVariable.

	aStream _ WriteStream on: (String new: 200).
	globalToo _ 0.
	aStream nextPutAll: 'declare ' ,
		(temp ifTrue: ['temp']
			ifFalse: [encoder classEncoding == UndefinedObject
					ifTrue: ['Global']
					ifFalse: [globalToo _ 1.  'Class Variable']]); cr.
	aStream nextPutAll: 'declare Undeclared'; cr.
	globalToo = 1 ifTrue: [aStream nextPutAll: 'declare Global'; cr].
	alternatives do:
		[:sel | aStream nextPutAll: sel; cr].
	aStream nextPutAll: 'cancel'.

	choice _ (PopUpMenu
				labels: aStream contents
				lines: (Array with: (globalToo + 2) with: (globalToo + alternatives size + 2)))
		startUpWithCaption:
(('Unknown variable: ', proposedVariable, '
please correct, or cancel:') asText makeBoldFrom: 19 to: 19 + proposedVariable size).
	(choice = 0) | (choice > (globalToo + alternatives size + 2))
		ifTrue: [^ self fail].

	requestor deselect.
	requestor selectInvisiblyFrom: userSelection first to: userSelection last.
	choice =1 ifTrue:
			[temp ifTrue: [^ self declareTempAndPaste: proposedVariable]
				ifFalse: [encoder classEncoding == UndefinedObject
					ifTrue: [^ self declareGlobal: proposedVariable]
					ifFalse: [^ self declareClassVar: proposedVariable]]].
	choice = 2 ifTrue: [^ self declareUndeclared: proposedVariable].
	(choice = 3) & (globalToo = 1) ifTrue: [^ self declareGlobal: proposedVariable].
	"Spelling correction"
	self substituteWord: (alternatives at: choice-2-globalToo)
			wordInterval: spot
			offset: 0.
	^ encoder encodeVariable: (alternatives at: choice-2-globalToo)! !

!Parser methodsFor: 'error correction' stamp: 'LC 11/4/2000 16:19'!
declareUndeclared: name
	| sym |
	sym _ name asSymbol.
	Undeclared at: sym put: nil.
	^ encoder global: (Undeclared associationAt: sym) name: sym! !


!PasteUpMorph methodsFor: 'world menu' stamp: 'fg 8/26/2002 19:56'!
keystrokeInWorld: evt
	"A keystroke was hit when no keyboard focus was in set, so it is sent here to the world instead.  This current implementation is regrettably hard-coded; until someone cleans this up, you may wish to edit this method to suit your personal taste in interpreting cmd-keys issued to the desktop."

	|  aChar isCmd |
	aChar _ evt keyCharacter.
	aChar asciiValue = 27 ifTrue: "escape key"
		[^ ActiveWorld putUpWorldMenuFromEscapeKey].
	isCmd _ evt commandKeyPressed and: [Preferences cmdKeysInText].
	(evt commandKeyPressed and: [Preferences eToyFriendly])
			ifTrue:
				[(aChar == $W) ifTrue: [^ self putUpWorldMenu: evt]].
	(isCmd and: [Preferences honorDesktopCmdKeys]) ifTrue:
		[(aChar == $o) ifTrue: [^ ActiveWorld activateObjectsTool].
		(aChar == $F) ifTrue: [^ CurrentProjectRefactoring currentToggleFlapsSuppressed].
		(aChar == $N) ifTrue:
			[Preferences classicNavigatorEnabled ifTrue: [^ Preferences togglePreference: #showProjectNavigator]].
		(aChar == $r) ifTrue: [^ ActiveWorld restoreMorphicDisplay].

		Preferences eToyFriendly
			ifFalse:
				[(aChar == $\) ifTrue: [^ SystemWindow sendTopWindowToBack].

				(aChar == $b) ifTrue: [^ Browser openBrowser].
				(aChar == $k) ifTrue: [^ Workspace open].
				(aChar == $m) ifTrue: [^ TheWorldMenu new adaptToWorld: World; newMorph].
				(aChar == $t) ifTrue: [^ self findATranscript: evt].
				(aChar == $w) ifTrue: [^ SystemWindow closeTopWindow].
				(aChar == $z) ifTrue: [^ self commandHistory undoOrRedoCommand].

				(aChar == $C) ifTrue: [^ self findAChangeSorter: evt].
				(aChar == $R) ifTrue: [^ self openRecentSubmissionsBrowser: evt].
				(aChar == $P) ifTrue: [^ self findAPreferencesPanel: evt].
				(aChar == $W) ifTrue: [^ self findAMessageNamesWindow: evt]]].
	self aerialKeystroke: evt! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'fg 8/26/2002 20:05'!
aerialKeystroke: evt 
	| targetMorph balloon |
	targetMorph _ self targetFor: evt.
	evt keyCharacter = Character backspace
		ifTrue: [targetMorph slideToTrash: evt;
				 delete.
			^ self].
	evt keyCharacter = Character tab 
		ifTrue: 
			[balloon _ MorphicWrapperConfiguration uniqueInstance codeBalloonMorphClass for: targetMorph aerialTarget hand: evt hand.
			balloon keyStroke: evt]! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'fg 7/30/2001 12:19'!
bindings
	| newProperty |
	^ self
		valueOfProperty: #bindings
		ifAbsent: 
			[newProperty _ WeakValueDictionary new.
			self setProperty: #bindings toValue: newProperty.
			newProperty]! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'r++ 11/27/1999 20:17'!
history
	^ self
		valueOfProperty: #history
		ifAbsent: [
			self history: (Dictionary new).
			^ self history]! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'r++ 11/20/1999 20:02'!
history: anObject
	self setProperty: #history toValue: anObject! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'r++ 11/27/1999 20:17'!
historyFor: anObject
	^ self history at: anObject class ifAbsent: [self history at: anObject class put: OrderedCollection new].! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'r++ 11/29/1999 00:46'!
namesFor: anObject
	"Answer the names of the receiver in the world. len 5/10/98 11:50"
	| answer |
	answer _ OrderedCollection new.
	self bindings associationsDo: [ :each |
		each value == anObject ifTrue: [answer add: each key]].
	^ answer! !

!PasteUpMorph methodsFor: 'aerial typing' stamp: 'DAB 1/11/2001 13:34'!
targetFor: evt 
	| |
	self
		morphsAt: evt cursorPoint
		unlocked: true
		do: [:first | ^ first.]! !

!PasteUpMorph methodsFor: 'morphic wrappers' stamp: 'LC 12/10/2000 18:21'!
runTo: aMorph
	"A world cannot run."
	"self shake: 6"! !

!PasteUpMorph methodsFor: 'morphic wrappers' stamp: 'LC 12/10/2000 18:25'!
slideToTrash: evt
	"do nothing"! !


!Point methodsFor: 'as yet unclassified' stamp: 'r++ 2/19/2000 22:20'!
atRandom
	^ self x atRandom @ self y atRandom! !

!Point methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:42'!
hasNiceWrapper
	^ true! !


!PopUpMenu class methodsFor: 'dialogs' stamp: 'LC 12/11/2000 08:07'!
confirm: queryString at: point
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	"PopUpMenu confirm: 'Are you hungry?'"

	^ self confirm: queryString trueChoice: 'Yes' falseChoice: 'No' at: point! !

!PopUpMenu class methodsFor: 'dialogs' stamp: 'LC 12/11/2000 08:08'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice at: point
	"Put up a yes/no menu with caption queryString. The actual wording 
	for the two choices will be as provided in the trueChoice and 
	falseChoice parameters. Answer true if the response is the true-choice, 
	false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."

	"PopUpMenu 
		confirm: 'Are you hungry?'
		trueChoice: 'yes, I''m famished'
		falseChoice: 'no, I just ate'"

	| menu choice |
	menu _ PopUpMenu labelArray: {trueChoice. falseChoice}.
	[(choice _ menu startUpWithCaption: queryString at: point) isNil] whileTrue.
	^ choice = 1! !


!Preferences class methodsFor: 'initialization' stamp: 'fg 7/10/2001 22:05'!
addManualWindowPlacementPreference
	" 
	Preferences addManualWindowPlacementPreference 
	"
	self 
		addPreference: #manualWindowPlacement
		category: #windows
		default: true
		balloonHelp: 'If true, small windows are attached to the hand when they first appear'

! !

!Preferences class methodsFor: 'initialization' stamp: 'fg 9/10/2002 00:10'!
addMorphicWrappersPreferences
	" 
	Preferences addMorphicWrappersPreferences 
	"
	|  categoryName | 
	categoryName _ #MorphicWrappers.
	self 
		addPreference: #exploreComplexMorphicWrappers
		category: categoryName
		default: false
		balloonHelp: 'If true, wrappers for most objets are shown within ObjectExplorer windows'.
	self 
		addPreference: #methodsInsideSystemWindows
		category: categoryName
		default: true
		balloonHelp: 'If true, methods are shown inside window, otherwise are shown with a special morph (MethodMathMorph)'.

	self 
		addPreference: #smallClassMorphicWrappers
		category: categoryName
		default: true
		balloonHelp: 'If true, ClassMorphicWrappers are shown in a tiny fashion, otherwise they are shown with its instance variables and category name'.

	self 
		addPreference: #carryingActivated
		category: categoryName
		default: false
		balloonHelp: 'If true, new morphic wrappers are carried with an invisible morph when they enter the world. Otherwise they just instantly stick to the hand'.
! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'fg 7/10/2001 22:13'!
maximumWindowArea
	"SystemWindows larger than this, wont be attached to the mouse"
	^  100000.0! !

!Preferences class methodsFor: 'convenience' stamp: 'fg 8/7/2001 16:35'!
open
	self openFactoredPanel
! !


!Rectangle methodsFor: 'as yet unclassified' stamp: 'r++ 2/19/2000 22:18'!
atRandom
	^ self extent atRandom + self topLeft! !


!ScrollPane methodsFor: 'scrolling' stamp: 'fg 8/6/2001 14:26'!
mouseEnter
	hasFocus _ true.
	self hideOrShowScrollBar.
! !


!PluggableListMorph class methodsFor: 'instance creation' stamp: 'LC 7/8/2000 19:51'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel dragEnabled: aBoolean
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."
	| answer |
	answer _ self new.
	answer setProperty: #dragEnabled toValue: true.
	^ answer
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel
! !


!SimpleButtonMorph methodsFor: 'events' stamp: 'LC 6/10/2000 13:35'!
doButtonAction: evt 
	"Perform the action of this button. Subclasses may override this method. 
	The default behavior is to send the button's actionSelector to its target 
	object with its arguments."
	| args |
	args _ arguments size < actionSelector numArgs
				ifTrue: [arguments , (Array with: evt)]
				ifFalse: [arguments].
	(target ~~ nil and: [actionSelector ~~ nil])
		ifTrue: [Cursor normal showWhile: [target perform: actionSelector withArguments: args]]! !


!String methodsFor: 'accessing' stamp: 'LC 2/4/2000 17:08'!
firstAlphaNumericSubstring
	"
	'Hola.' firstAlphaNumericSubstring
	"
	| i |
	i _ self findFirst: [:char | char isAlphaNumeric not].
	i = 0 ifTrue: [i _ self size + 1].
	^ i <= 1 ifTrue: [''] ifFalse: [self copyFrom: 1 to: i - 1]! !

!String methodsFor: 'editing' stamp: 'LC 12/31/1998 13:35'!
insert: substring at: index
	index = 1 ifTrue: [^ substring, self].
	^ (self copyFrom: 1 to: index - 1), substring, (self copyFrom: index to: self size)! !

!String methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !


!SystemWindow methodsFor: 'open/close' stamp: 'fg 8/6/2001 15:18'!
attachedToHand: aHand
	| deltaX deltaY |
	deltaX _ self bounds extent x // 6.
	deltaY _ label bounds extent y // 2.
	aHand attachMorph: self withDelta: deltaX@deltaY! !

!SystemWindow methodsFor: 'open/close' stamp: 'LC 12/10/2000 09:35'!
closeBoxHit: evt
	"The user clicked on the close-box control in the window title.  For Mac users only, the Mac convention of option-click-on-close-box is obeyed if the mac option key is down."

	Preferences dismissAllOnOptionClose ifTrue:
		[Sensor rawMacOptionKeyPressed ifTrue:
			[^ self world closeUnchangedWindows]].
	self delete: evt
! !

!SystemWindow methodsFor: 'open/close' stamp: 'LC 6/10/2000 13:37'!
delete: evt
	| thisWorld sketchEditor aPaintBox |
	self mustNotClose ifTrue: [^ self].
	model okToChange ifFalse: [^ self].
	thisWorld _ self world.
	sketchEditor _ self extantSketchEditor.
	self isFlexed
		ifTrue: [owner delete]
		ifFalse: [super delete].
	model windowIsClosing; release.
	model _ nil.
	sketchEditor ifNotNil:
		[sketchEditor deleteSelfAndSubordinates.
		thisWorld notNil ifTrue:
			[(aPaintBox _ thisWorld paintBoxOrNil) ifNotNil: [aPaintBox delete]]].
		
	SystemWindow noteTopWindowEvent: evt.
! !


!SystemWindow class methodsFor: 'top window' stamp: 'LC 6/10/2000 13:39'!
noteTopWindowEvent: evt
	| aWorld newTop |
	"TopWindow must be nil or point to the top window in this project."
	TopWindow _ nil.
	(aWorld _ evt hand world) ifNil: [^ self].
	newTop _ nil.
	aWorld submorphsDo:
		[:m | (m isKindOf: SystemWindow) ifTrue:
			[(newTop == nil and: [m activeOnlyOnTop])
				ifTrue: [newTop _ m].
			(m model isKindOf: Project)
				ifTrue: ["This really belongs in a special ProjWindow class"
						m label ~= m model name ifTrue: [m setLabel: m model name]]]].
	newTop == nil ifTrue: [evt hand newKeyboardFocus: nil] ifFalse: [newTop activate]! !


!UndefinedObject methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:42'!
hasNiceWrapper
	^ true! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Preferences addMorphicWrappersPreferences.
MorphicWrapperConfiguration niceStyle.
Preferences enable: #mouseOverForKeyboardFocus.

"Preferences addManualWindowPlacementPreference."
"Preferences lightenStandardWindowPreferences."!

